#!/usr/local/bin/perl

require "./setup.pl";

#擾
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
@wday_array = ('SUN','MON','TUE','WED','THU','FRI','SAT');
$date_now = sprintf("%01d\/%01d(%s)%02d\:%02d",$mon +1,$mday,$wday_array[$wday],$hour,$min);

#f[^̓ǂݍ
if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'}); }
else { $buffer = $ENV{'QUERY_STRING'}; }

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {

	($name, $value) = split(/=/, $pair);
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	&jcode'convert(*name,'sjis');
	&jcode'convert(*value,'sjis');

	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/\t//g;

	if ($name eq '_ZAIKO') {

		push(@ZAIKO_KANRI,$value);
		($TARGET_FILE,$CODE,$KAZU) = split(/:/,$value,3);
		$ZAIKO_TARGET{$TARGET_FILE} = 1;
	}
	else {
		$in{$name} = $value;
		push(@out,"$name\0$value");
	}
}

if ($center) { $center1 = '<center>'; $center2 = '</center>'; }

if ($in{'_order'} =~ /\D/) { exit; }

if ($in{'_file'} eq '') { &error('ݒG[','gp鏤it@Cݒ肳Ă܂.'); }
if (!-e "$base_dir$in{'_file'}\.csv") { &error('ݒG[',"iݒt@C$in{'_file'}܂."); }

$lockfile = $tmp_dir . "$in{'_file'}\.lock";

$od_check = (eval { opendir(DIR,$base_dir); }, $@ eq "");
if (!$od_check) { &error("G[","t@Cꗗ擾ł܂."); }

($cookie_name,$els) = split(/\./,$in{'_file'},2);
@newls = ();

@list = readdir(DIR); # t@C̒o

foreach $file (@list) {

	next if -d $file;

	if ($file =~ /^$cookie_name\./) {

		#iݒt@CJ(戵if[^ǂݍ)
		if (!open(FILE,"$base_dir$file")) { &error('G[',"it@C$fileǂݏo܂."); }

		#t@Cnh'FILE'Psf[^ǂ
		while (<FILE>) {

			#
			s/\t//g;
			s/\n//g;

			#sV[v܂͋s̏ꍇ͎
			if (/^#/) { next; }
			if (/^$/) { next; }

			#f[^o
			($code,$name,$tanka,$tax,$rem,$url,$zaiko,$type) = &DecodeCSV($_);

			$name{$code} = $name;
			$tanka =~ s/\,//g; $tanka =~ s/\\//g; $tanka{$code} = $tanka;
			$taxrate = $tax;
			$rem{$code} = $rem;
			$url{$code} = $url;
			$zaiko{$code} = $zaiko;
			$type{$code} = $type;

			if ($taxrate == -3) { $taxm{$code} = "(ō)"; }
			elsif ($taxrate == -2) { $taxm{$code} = "(sې)"; }
			elsif ($taxrate == -1) { $taxm{$code} = "(ې)"; }
			else { $taxm{$code} = ""; }

			if ($taxrate =~ /\-/) { $taxrate = 0; } # ł̐ݒl-0%ɂ
			$tax{$code} = $taxrate;
		}
		close(FILE);
	}
}

close(DIR);

#iR[hL[Ƃ%orderɐʂi[
while (($key,$val) = each %in) {

	if ($key =~ /\;(.+)\;/) { $code = $1; }

	#폜鏤iR[h擾
	if ($in{'_action'} eq 'delete') {

		if ($key =~ /\;(.+)\;/) { $delete_id = $1; last; }
	}
	#iR[ȟ`œ͂Aʂ0ȊO̐w肳Ăꍇɏ
	elsif ($val =~ /\d+/ && $val != 0) {

		if ($key =~ /\;(.+)\;/) {

			$code = $1;
			if ($name{$code} eq '') { &error("G[","iR[h$codeiݒt@C$in{'_file'}ɑ݂ĂȂ\\̂őIł܂.","Ǘ҂ɂ₢킹."); }
			$w = 1; $order{$code} = $val;
		}
	}
	elsif ($key =~ /\;(.+)\;/ && $val =~ /\D/) { &error("G[","iR[h$code̐ʂpȊOŎw肳Ă܂.","pœ͂Ă."); }
}

#NbL[̎擾
$cookies = $ENV{'HTTP_COOKIE'};

@pairs = split(/;/,$cookies);
foreach $pair (@pairs) {

	($key,$val) = split(/=/,$pair,2);
	$key =~ s/ //g;

	if ($key eq $cookie_name) {

		@pairs = split(/,/,$val);
		foreach $pair (@pairs) {

			($key,$val) = split(/:/,$pair,2);
			$val =~ s/\0//;
			$COOKIE{$key} = $val;
		}
		last;
	}
}

$in{'_order'} =~ s/\D//g;

#폜
if ($in{'_action'} eq 'delete') {

	#oXPbgt@CJ
	if (!open(ORDER,"$tmp_dir$in{'_order'}\.bkt")) { &error("IĂ܂"); }
	@base = <ORDER>;
	close(ORDER);

	@new = grep(!/^.+\t($delete_id)\t/,@base);

	if (!@new) { $delall = 1; unlink "$tmp_dir$in{'_order'}\.bkt"; }
	else {
		if (!open(FILE,"> $tmp_dir$in{'_order'}\.bkt")) { &error("ݒG[","oXPbgt@CɍċL^ł܂."); }
		print FILE @new;
		close(FILE);
	}
}

#o^
elsif ($w) {

	if ($COOKIE{'OrderNo'} eq '') {

		$COOKIE{'OrderNo'} = sprintf("%04d%02d%02d%02d%02d%02d",$year +1900,$mon +1,$mday,$hour,$min,$sec);

		#VK
		if (!open(FILE,"> $tmp_dir$COOKIE{'OrderNo'}\.bkt")) { &error("ݒG[","ƃfBNgݒ肳Ă܂."); }
	}
	else {
		#ǉ
		if (!open(FILE,">> $tmp_dir$COOKIE{'OrderNo'}\.bkt")) { &error("ݒG[","ƃfBNgݒ肳Ă܂."); }
	}

	#iR[hƐʂt@CɋL^
	while (($code,$kazu) = each %order) { print FILE "$in{'_file'}\t$code\t$kazu\n"; }

	close(FILE);
	chmod(0666,"$tmp_dir$COOKIE{'OrderNo'}\.bkt");
}

#oXPbgꎞt@C̈ꗗ
$od_check = (eval { opendir(DIR,$tmp_dir); }, $@ eq "");
if (!$od_check) { &error("G[","opendir()ɒvIȃG[܂."); }
@ls = readdir(DIR);
close(DIR);

#cꎞt@C폜
($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg) = gmtime(time - 2*24*60*60);
$limit = sprintf("%04d%02d%02d%02d%02d%02d",$yearg +1900,$mong +1,$mdayg,$hourg,$ming,$secg);

foreach $file (@ls) {

	next if $file eq '.';
	next if $file eq '..';
	next if -d $file;
	if ($file =~ /(\d+)\.bkt/) { if ($1 < $limit) { unlink "$tmp_dir$file"; }}
}

#ZbgNbL[̓e
if ($delall) { $set_cookie = ""; }
else { $set_cookie = "OrderNo\:$COOKIE{'OrderNo'}"; }

#ʃNbL[̐ݒ
print "Set-Cookie: $cookie_name=$set_cookie\n";

#ʏo͊Jn
print "Content-type: text/html\n\n";

print <<"EOF";
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
<SCRIPT language="JavaScript">
<!--
function PageBack(){ history.back(); }
//-->
</SCRIPT>
</HEAD>
$body
$center1
$title
EOF

#oXPbgt@CJ
if (open(ORDER,"$tmp_dir$COOKIE{'OrderNo'}\.bkt")) {

	print <<"EOF";
	<table><tr><td>$msg_top</td></tr></table>
	<form method=POST action="cargo.cgi">
	<input type=hidden name="_file" value="$in{'_file'}">
	<input type=hidden name="_order" value="$COOKIE{'OrderNo'}">
	<input type=hidden name="_action" value="delete">
	<table border=3 cellpadding=1 cellspacing=2>
	<tr>
	<th bgcolor=#555555><font color=#ffffff size=+1>iR[h</font></th>
	<th bgcolor=#555555><font color=#ffffff size=+1>i</font></th>
	<th bgcolor=#555555><font color=#ffffff size=+1>l</font></th>
	<th bgcolor=#555555><font color=#ffffff size=+1>P(~)</font></th>
	<th bgcolor=#555555><font color=#ffffff size=+1></font></th>
EOF
	if ($taxps) { #łꍇ

		print <<"EOF";
		<th bgcolor=#555555><font color=#ffffff size=+1>ŕʌv(~)</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>(~)</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>ōv(~)</font></th>
EOF
	}
	else {
		print <<"EOF";
		<th bgcolor=#555555><font color=#ffffff size=+1>v(~)</font></th>
EOF
	}

	print <<"EOF";
	<th bgcolor=#555555><font color=#ffffff size=+1></font></th>
	</tr>
EOF
	#Wv
	&cal1;

	foreach $code (sort keys %list) { # iR[h
#	foreach $code (sort { $list{$b} <=> $list{$a} } keys %list) { # ʂ

		#Wv
		&cal2;

		#iƔl̃Rsɕϊ
		$name{$code} =~ s/\:/<br>/g;
		$rem{$code} =~ s/\:/<br>/g;

		$zaiko_mes = '';
		if ($zaiko{$code} ne '') {

			if ($zaiko{$code} == 0) { $zaiko_err = 1; $zaiko_mes = '<br><font size=-1>݌ɖI(Uĉ)</font>'; }
			if ($list{$code} > $zaiko{$code}) { $zaiko_err = 1; $zaiko_mes = '<br><font size=-1>݌ɕsI(Uĉ)</font>'; }
		}

		$c++;
		if ($c % 2) { $bg = "#ffeedd"; } else { $bg = "#ffffff"; } #PsɃZ̔wiFւ

		print <<"EOF";
		<tr>
		<td bgcolor=$bg>$code</td>
		<td bgcolor=$bg>$name{$code}</td>
		<td bgcolor=$bg>$rem{$code}&nbsp;</td>
		<td bgcolor=$bg align=right>$tanka2</td>
		<td bgcolor=$bg align=right>$kazu2$zaiko_mes</td>
EOF
		if ($tax == 0) { $tax2 = ""; } # ŗ0%̏ꍇ͕\Ȃ

		if ($taxps) {

			print <<"EOF";
			<td bgcolor=$bg align=right>$kei2</td>
			<td bgcolor=$bg align=right><font size=-1>$taxm{$code}</font> $tax2</td>
EOF
		}

		print <<"EOF";
		<td bgcolor=$bg align=right>$kei2_and_tax</td>
		<td bgcolor=$bg><input type=submit name=";$code;" value=""></td>
		</tr>
EOF
	}

	close(ORDER);

	$taxs = int($taxs);
	$gokei = int($gokei);

	#J}}
	1 while $keis =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	1 while $gokei =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	1 while $taxs =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	1 while $kazu =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	print <<"EOF";
	<tr>
	<td bgcolor=#ffaaaa colspan=4 align=center><font size=-1>$message1</font></td>
	<td bgcolor=#ffaaaa align=right><strong>$kazuall</strong></td>
EOF
	if ($taxps) {

		print <<"EOF";
		<td bgcolor=#ffaaaa align=right><strong>$keis</strong></td>
		<td bgcolor=#ffaaaa align=right><strong>$taxs</strong></td>
EOF
	}

	print <<"EOF";
	<td bgcolor=#ff8888 align=right><strong><font size=+1>$gokei</font></strong></td>
	<td bgcolor=#ffaaaa>$taxmes</td>
	</tr>
	</table><p>
	</form>
	<p>
	<table><tr><td>$msg_btm</td></tr></table>
EOF
	if ($zaiko_err) {

		print <<"EOF";
		<h3>݌ɕs̏iIĂ̂Œł܂</h3>
EOF
	}
	else {
		print <<"EOF";
		<form method=POST action="$order_cgi">
		<input type=hidden name="_file" value="$in{'_file'}">
		<input type=hidden name="_order" value="$COOKIE{'OrderNo'}">
		<input type=hidden name="_action" value="mailform">
		<input type=submit value="͐ւi݂  NEXT">
		</form>
EOF
	}
}
else { print "<h3>IĂ܂</h3>\n"; }

print <<"EOF";
<h3>[<A HREF="JavaScript:history.back()">Ỏ</A>]
[<A HREF="cargo.cgi?_file=$in{'_file'}">ŐV̂̒g</A>]
[<A HREF="$top">$go_name</A>]</h3>
$center2
</body></html>
<!-- $COOKIE{'OrderNo'} -->
EOF

exit;

sub cal1 {

	#i΍Z
	foreach (<ORDER>) {

		s/\n//;
		($target_file,$code,$kazu) = split(/\t/,$_,3);
		$list{$code} += $kazu;
		$target_file{$code} = $target_file;
	}
}

sub cal2 {

	#vʁ~P
	$kei = $kei2 = $list{$code} * $tanka{$code};
	1 while $kei2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	$kazu2 = $list{$code};
	$tanka2 = $tanka{$code};
	1 while $kazu2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	1 while $tanka2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	if ($taxps) {

		#Łv~ŗ100
		$tax = $kei * $tax{$code} / 100;
		$tax2 = int($tax);
		1 while $tax2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

		#ōvv{
		$kei_and_tax = $kei + $tax;
		$kei2_and_tax = int($kei_and_tax);
	}
	else { $kei_and_tax = $kei2_and_tax = $kei; $taxmes = '(ō)'; }

	1 while $kei2_and_tax =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	#Z
	$keis += $kei;
	$gokei += $kei_and_tax;
	$taxs += $tax;
	$kazuall += $list{$code};
}

sub DecodeCSV {

	local($text) = @_;
	local(@fields) = ();
	local($a);

	$text =~ s/\n//;
	if ($text eq '') { return (); }

	while ($text =~ m/"([^\\]*(\\.[^\\]*)*)",?|([^,]+),?|,/g) {

		$a = defined($1) ? $1 : $3;
		$a =~ s/""/"/g;

		$a =~ s/&/&amp;/g;
		$a =~ s/"/&quot;/g;
		$a =~ s/</&lt;/g;
		$a =~ s/>/&gt;/g;

		push(@fields,$a);
	}
	push(@fields, undef) if $text =~ m/,$/;

	@fields;
}

sub lock {

	# bN̎ symlink()D
	$symlink_check = (eval { symlink("",""); }, $@ eq "");
	if (!$symlink_check) {

		$c = 0;
		while(-f "$lockfile") { # file

			$c++;
			if ($c >= 3) { &error('gCG[','܍GĂ\܂.','߂ĂxsĂ݂Ă.'); }
			sleep(2);
		}
		open(LOCK,">$lockfile");
		close(LOCK);
	}
	else {
		local($retry) = 3;
		while (!symlink(".", $lockfile)) { # symlink

			if (--$retry <= 0) { &error('gCG[','܍GĂ\܂.','߂ĂxsĂ݂Ă.'); }
			sleep(2);
		}
	}
}

sub error {

	local (@msg) = @_;
	local ($i);

	if (-e $lockfile) { unlink($lockfile); }

	print "Content-type: text/html\n\n";

	print <<"EOF";
	<HTML>
	<HEAD>
	<TITLE>$title_bar</TITLE>
	<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	$center1
	<h1>$_[0]</h1>
	<table><tr><td>
EOF
	foreach $i (1 .. $#msg) { print "$msg[$i]<br>\n"; }

	print <<"EOF";
	</td></tr></table>
	<h4>[<A HREF="JavaScript:history.back()">Ỏʂɖ߂</A>]</h4>
	$center2
	</body></html>
EOF
	exit;
}
