#!/usr/local/bin/perl

require "./setup.pl";

#擾
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
@wday_array = ('SUN','MON','TUE','WED','THU','FRI','SAT');
$date_now = sprintf("%01d\/%01d(%s)%02d\:%02d",$mon +1,$mday,$wday_array[$wday],$hour,$min);

#f[^̓ǂݍ
if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'}); }
else { $buffer = $ENV{'QUERY_STRING'}; }

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {

	($name, $value) = split(/=/, $pair);
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	&jcode'convert(*name,'sjis');
	&jcode'convert(*value,'sjis');

	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/\t//g;

	if ($name =~ /_EMAIL/) { push(@sendjun,"d["); $sendvalue{"d["} = $value; }
	elsif ($name =~ /^_|^ORDER/) { ; }
	else { push(@sendjun,$name); $sendvalue{$name} = $value; }

	if ($name eq '_ZAIKO') {

		push(@ZAIKO_KANRI,$value);
		($TARGET_FILE,$CODE,$KAZU) = split(/:/,$value,3);
		$ZAIKO_TARGET{$TARGET_FILE} = 1;
	}
	else {
		$in{$name} = $value;
		push(@out,"$name\0$value");
	}
}

if ($center) { $center1 = '<center>'; $center2 = '</center>'; }

if ($in{'_cancel'} ne "") { &error('LZ{^܂','܂̃I[_[̂\݂͂܂łB',"<A HREF=\"$top\">$go_name</A>"); }
if ($in{'_order'} =~ /\D/) { exit; }

if ($in{'_file'} eq '') { &error('ݒG[','gp鏤it@Cݒ肳Ă܂.'); }
if (!-e "$base_dir$in{'_file'}\.csv") { &error('ݒG[',"iݒt@C$in{'_file'}܂."); }

$lockfile = $tmp_dir . "$in{'_file'}\.lock";

$od_check = (eval { opendir(DIR,$base_dir); }, $@ eq "");
if (!$od_check) { &error("G[","t@Cꗗ擾ł܂."); }

($cookie_name,$els) = split(/\./,$in{'_file'},2);
@newls = ();

@list = readdir(DIR); # t@C̒o

foreach $file (@list) {

	next if -d $file;

	if ($file =~ /^$cookie_name\./) {

		#iݒt@CJ(戵if[^ǂݍ)
		if (!open(FILE,"$base_dir$file")) { &error('G[',"it@C$fileǂݏo܂."); }

		#t@Cnh'FILE'Psf[^ǂ
		while (<FILE>) {

			#
			s/\t//g;
			s/\n//g;

			#sV[v܂͋s̏ꍇ͎
			if (/^#/) { next; }
			if (/^$/) { next; }

			#f[^o
			($code,$name,$tanka,$tax,$rem,$url,$zaiko,$type) = &DecodeCSV($_);

			$name{$code} = $name;
			$tanka =~ s/\,//g; $tanka =~ s/\\//g; $tanka{$code} = $tanka;
			$taxrate = $tax;
			$rem{$code} = $rem;
			$url{$code} = $url;
			$zaiko{$code} = $zaiko;
			$type{$code} = $type;

			if ($taxrate == -3) { $taxm{$code} = "(ō)"; }
			elsif ($taxrate == -2) { $taxm{$code} = "(sې)"; }
			elsif ($taxrate == -1) { $taxm{$code} = "(ې)"; }
			else { $taxm{$code} = ""; }

			if ($taxrate =~ /\-/) { $taxrate = 0; } # ł̐ݒl-0%ɂ
			$tax{$code} = $taxrate;
		}
		close(FILE);
	}
}

close(DIR);

#NbL[̎擾
$cookies = $ENV{'HTTP_COOKIE'};

@pairs = split(/;/,$cookies);
foreach $pair (@pairs) {

	($key,$val) = split(/=/,$pair,2);
	$key =~ s/ //g;

	if ($key eq $cookie_name) {

		@pairs = split(/,/,$val);
		foreach $pair (@pairs) {

			($key,$val) = split(/:/,$pair,2);
			$COOKIE{$key} = $val;
		}
		last;
	}
}

#tH[
if ($in{'_action'} eq 'mailform') { &mailform; }

#mFtH[
elsif ($in{'_action'} eq 'confirm') { &confirm; }

#MtH[
elsif ($in{'_action'} eq 'mail') { &mail; }

sub cal1 {

	#i΍Z
	foreach (<ORDER>) {

		s/\n//;
		($target_file,$code,$kazu) = split(/\t/,$_,3);
		$list{$code} += $kazu;
		$target_file{$code} = $target_file;
	}
}

sub cal2 {

	#vʁ~P
	$kei = $kei2 = $list{$code} * $tanka{$code};
	1 while $kei2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	$kazu2 = $list{$code};
	$tanka2 = $tanka{$code};
	1 while $kazu2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	1 while $tanka2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	if ($taxps) {

		#Łv~ŗ100
		$tax = $kei * $tax{$code} / 100;
		$tax2 = int($tax);
		1 while $tax2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

		#ōvv{
		$kei_and_tax = $kei + $tax;
		$kei2_and_tax = int($kei_and_tax);
	}
	else { $kei_and_tax = $kei2_and_tax = $kei; $taxmes = '(ō)'; }

	1 while $kei2_and_tax =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	#Z
	$keis += $kei;
	$gokei += $kei_and_tax;
	$taxs += $tax;
	$kazuall += $list{$code};
}

sub mailform {

	#菤Ɋւ@ɔ\t@CJ
	if (!open(FILE,"$base_dir$hanbai")) { &error('G[',"菤Ɋւ@ɔ\t@Cǂݏo܂."); }
	@HANBAI = <FILE>;
	close(FILE);

	#󒍃tH[t@CJ
	if (!open(FILE,"$base_dir$juchu")) { &error('G[',"󒍃tH[t@Cǂݏo܂."); }
	@JUCHU = <FILE>;
	close(FILE);

	#ʏo͊Jn
	print "Content-type: text/html\n\n";

	print <<"EOF";
	<HTML>
	<HEAD>
	<TITLE>$title_bar</TITLE>
	<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	$center1
	<h1>stH[t</h1>
EOF

	#oXPbgt@CJ
	if (open(ORDER,"$tmp_dir$COOKIE{'OrderNo'}\.bkt")) {

		print <<"EOF";
		<form method=POST action="$order_cgi">
		<input type=hidden name="_file" value="$in{'_file'}">
		<input type=hidden name="_order" value="$COOKIE{'OrderNo'}">
		<input type=hidden name="_action" value="confirm">
		<table border=3 cellpadding=1 cellspacing=2>
		<tr>
		<th bgcolor=#555555><font color=#ffffff size=+1>iR[h</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>i</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>l</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>P(~)</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1></font></th>
EOF
		#łꍇ
		if ($taxps) {

			print <<"EOF";
			<th bgcolor=#555555><font color=#ffffff size=+1>ŕʌv(~)</font></th>
			<th bgcolor=#555555><font color=#ffffff size=+1>(~)</font></th>
			<th bgcolor=#555555><font color=#ffffff size=+1>ōv(~)</font></th>
EOF
		}
		else {
			print <<"EOF";
			<th bgcolor=#555555><font color=#ffffff size=+1>v(~)</font></th>
EOF
		}

		print <<"EOF";
		</tr>
EOF
		#Wv
		&cal1;

		foreach $code (sort keys %list) { # iR[h
#		foreach $code (sort { $list{$b} <=> $list{$a} } keys %list) { # ʂ

			#Wv
			&cal2;

			#iƔl̃RXy[Xɕϊ
			$name{$code} =~ s/\:/ /g;
			$rem{$code} =~ s/\:/ /g;

			#݌ɊǗΏۃf[^
			print "<input type=hidden name=\"_ZAIKO\" value=\"$target_file{$code}:$code:$list{$code}\">\n"; # (v3.44ŏC)

			$c++;
			if ($c % 2) { $bg = "#ffeedd"; } else { $bg = "#ffffff"; } #PsɃZ̔wiFւ

			print <<"EOF";
			<tr>
			<td bgcolor=$bg>$code</td>
			<td bgcolor=$bg>$name{$code}</td>
			<td bgcolor=$bg>$rem{$code}&nbsp;</td>
			<td bgcolor=$bg align=right>$tanka2</td>
			<td bgcolor=$bg align=right>$kazu2</td>
			<input type=hidden name="ORDER" value="$code $name{$code}">
EOF
			if ($mailrem) { print "<input type=hidden name=\"ORDER\" value=\"$rem{$code}\">\n"; }

			if ($taxps) {

				if ($tax == 0) { $tax2 = ""; } # ŗ0%̏ꍇ͕\Ȃ

				print <<"EOF";
				<td bgcolor=$bg align=right>$kei2</td>
				<td bgcolor=$bg align=right><font size=-1>$taxm{$code}</font> $tax2</td>
				<input type=hidden name="ORDER" value="\@$tanka2~~$kazu2$kei2~.">
EOF
			}
			else {

				print <<"EOF";
				<input type=hidden name="ORDER" value="\@$tanka2~$kazu2$kei2_and_tax\.">
EOF
			}

			print <<"EOF";
			<td bgcolor=$bg align=right>$kei2_and_tax</td>
			</tr>
EOF
		}

		close(ORDER);

		$taxs = int($taxs);
		$gokei = int($gokei);

		#J}}
		1 while $keis =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		1 while $gokei =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		1 while $taxs =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		1 while $kazu =~ s/(.*\d)(\d\d\d)/$1,$2/g;

		print <<"EOF";
		<tr>
		<th bgcolor=#ffaaaa colspan=4><font size=-1 align=center>ʍv </font></th>
		<td bgcolor=#ffaaaa align=right><strong>$kazuall</strong></td>
EOF
		if ($taxps) {

			print <<"EOF";
			<input type=hidden name="ORDER" value=" $taxs~">
			<td bgcolor=#ffaaaa align=right><strong>$keis</strong></td>
			<td bgcolor=#ffaaaa align=right><strong>$taxs</strong></td>
EOF
		}

		print <<"EOF";
		<td bgcolor=#ff8888 align=right>$taxmes <strong><font size=+1>$gokei</font></strong></td>
		</tr>
		</table>
		<p>
		<input type=hidden name="ORDER" value="v $gokei~ $taxmes">
		<table><tr><td>
EOF
		foreach (@JUCHU) { print; }

		print <<"EOF";
		<p>
		Ĺu菤Ɋւ@ɂ\\vǂ݂܂H<br>
		<input type=radio name="_confirm" value="0" checked> ǂł܂
		<input type=radio name="_confirm" value="1"> m܂
		<p>
		<input type=submit value="  \\݂̍ŏImF  ">
		</td></tr></table>
		</form>
EOF
		print <<'EOF';
		<br><h3>s菤Ɋւ@ɂ\t</h3>
EOF
		print "<form><textarea cols=80 rows=10>";
		foreach (@HANBAI) { print; }

		if ($reg_name eq '' || $reg_code eq '') { $reg = "o^"; }
		else { $reg = "$reg_name o^R[hF$reg_code"; }

		print "\n"; #폜Ȃ.
		print "\\tgEGA̎gpɊւ\\\n";
		print "  \\tgFVbsOoXPbgVXeEv(c)www.rescue.ne.jp\n";
		print "  VFAEGAo^F$reg\n";
		print "</textarea></form><p>\n";
	}
	else { print "<h3>IĂ܂</h3>\n"; }

	print <<"EOF";
	<h3><hr>[<A HREF="JavaScript:history.back()">Ỏ</A>]
	[<A HREF="$top">$go_name</A>]</h3>
	$center2
	</body></html>
EOF
	exit;
}

sub confirm {

	if (!$in{'_confirm'}) { &error('mF̂肢','ɊւdvȂƂł̂ŁA菤Ɋւ@ɂ\ǂ݂.'); }
	unless ($in{'_EMAIL'} =~ /\b[-\w.]+@[-\w.]+\.[-\w]+\b/) { &error('L܂','d[͔pŐL.'); }

	foreach $zaiko_file (keys %ZAIKO_TARGET) { # (v3.44Œǉ)

		@NEW = ();

		if (!open(IN,"$base_dir$zaiko_file\.csv")) { &error('G[',"$zaiko_fileI[vł܂."); }
		@lines = <IN>;
		close(IN);

		foreach $line (@lines) {

			$line =~ s/\n//g;
			$zaiko = '';

			#f[^o
			($code,$name,$tanka,$tax,$rem,$url,$zaiko,$type) = &DecodeCSV($line);

			if ($zaiko =~ /\d+/ && $zaiko ne '') {

				foreach $target (@ZAIKO_KANRI) {

					($TARGET_FILE,$CODE,$KAZU) = split(/:/,$target,3);

					$old = $zaiko;
					if ($CODE eq $code && $zaiko == 0) { &error("݌ɃG[","iR[h$codȅi͍݌ɂȂ܂.",'ʂ߂ēYi폜Ă.'); }
					if ($CODE eq $code) { $zaiko = $zaiko - $KAZU; }
					if ($zaiko < 0) { &error("݌ɃG[","iR[h$codȅi݌ɐ($old)鐔($KAZU)IĂ܂.",'ʂ߂ēYi폜ĂA߂ďiI.'); }
				}
			}
		}
	}

	#ʏo͊Jn
	print "Content-type: text/html\n\n";

	print <<"EOF";
	<HTML>
	<HEAD>
	<TITLE>$title_bar</TITLE>
	<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	function Submit()
	{
		f = confirm("\\݂܂A낵łH");
		if (f) { document.form1.submit(); }
	}
	//-->
	</SCRIPT>
	</HEAD>
	$body
	$center1
	<h1>s\\݂̍ŏImFt</h1>
EOF

	#oXPbgt@CJ
	if (open(ORDER,"$tmp_dir$COOKIE{'OrderNo'}\.bkt")) {

		print <<"EOF";
		<form method=POST action="$order_cgi" name="form1">
		<input type=hidden name="_file" value="$in{'_file'}">
		<input type=hidden name="_order" value="$in{'_order'}">
		<input type=hidden name="_action" value="mail">
		<input type=hidden name="_SUBJECT" value="$in{'_SUBJECT'}">
		<table border=3 cellpadding=1 cellspacing=2 width=80%>
		<tr>
		<th bgcolor=#555555><font color=#ffffff size=+1>iR[h</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>i</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>l</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>P(~)</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1></font></th>
EOF
		#łꍇ
		if ($taxps) {

			print <<"EOF";
			<th bgcolor=#555555><font color=#ffffff size=+1>ŕʌv(~)</font></th>
			<th bgcolor=#555555><font color=#ffffff size=+1>(~)</font></th>
			<th bgcolor=#555555><font color=#ffffff size=+1>ōv(~)</font></th>
EOF
		}
		else {
			print <<"EOF";
			<th bgcolor=#555555><font color=#ffffff size=+1>v(~)</font></th>
EOF
		}

		print <<"EOF";
		</tr>
EOF
		#Wv
		&cal1;

		foreach $code (sort keys %list) { # iR[h
#		foreach $code (sort { $list{$b} <=> $list{$a} } keys %list) { # ʂ

			#Wv
			&cal2;

			#iƔl̃RXy[Xɕϊ
			$name{$code} =~ s/\:/ /g;
			$rem{$code} =~ s/\:/ /g;

			#݌ɊǗΏۃf[^
			print "<input type=hidden name=\"_ZAIKO\" value=\"$target_file{$code}:$code:$list{$code}\">\n"; # (v3.44ŏC)

			$c++;
			if ($c % 2) { $bg = "#ffeedd"; } else { $bg = "#ffffff"; } #PsɃZ̔wiFւ

			print <<"EOF";
			<tr>
			<td bgcolor=$bg>$code</td>
			<td bgcolor=$bg>$name{$code}</td>
			<td bgcolor=$bg>$rem{$code}&nbsp;</td>
			<td bgcolor=$bg align=right>$tanka2</td>
			<td bgcolor=$bg align=right>$kazu2</td>
			<input type=hidden name="ORDER" value="$code $name{$code}">
EOF
			if ($mailrem) { print "<input type=hidden name=\"ORDER\" value=\"$rem{$code}\">\n"; }

			if ($taxps) {

				if ($tax == 0) { $tax2 = ""; } # ŗ0%̏ꍇ͕\Ȃ

				print <<"EOF";
				<td bgcolor=$bg align=right>$kei2</td>
				<td bgcolor=$bg align=right><font size=-1>$taxm{$code}</font> $tax2</td>
				<input type=hidden name="ORDER" value="\@$tanka2~~$kazu2$kei2~.">
EOF
			}
			else {

				print <<"EOF";
				<input type=hidden name="ORDER" value="\@$tanka2~$kazu2$kei2_and_tax\.">
EOF
			}

			print <<"EOF";
			<td bgcolor=$bg align=right>$kei2_and_tax</td>
			</tr>
EOF
		}

		close(ORDER);

		$taxs = int($taxs);
		$gokei = int($gokei);

		#J}}
		1 while $keis =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		1 while $gokei =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		1 while $taxs =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		1 while $kazu =~ s/(.*\d)(\d\d\d)/$1,$2/g;

		print <<"EOF";
		<tr>
		<th bgcolor=#ffaaaa colspan=4><font size=-1 align=center>ʍv </font></th>
		<td bgcolor=#ffaaaa align=right><strong>$kazuall</strong></td>
EOF
		if ($taxps) {

			print <<"EOF";
			<input type=hidden name="ORDER" value="ŕʍv $keis~">
			<input type=hidden name="ORDER" value=" $taxs~">
			<td bgcolor=#ffaaaa align=right><strong>$keis</strong></td>
			<td bgcolor=#ffaaaa align=right><strong>$taxs</strong></td>
EOF
		}

		print <<"EOF";
		<td bgcolor=#ff8888 align=right>$taxmes <strong><font size=+1>$gokei</font></strong></td>
		</tr>
		</table>
		<input type=hidden name="ORDER" value="v $gokei~ $taxmes\.">
EOF
		print <<"EOF";
		<table border=3 cellpadding=1 cellspacing=2 width=80%>
		<tr>
		<th bgcolor=#555555><font color=#ffffff size=+1>ږ</font></th>
		<th bgcolor=#555555><font color=#ffffff size=+1>e</font></th>
		</tr>
EOF
		foreach $key (@sendjun) {

			$val = $val2 = $sendvalue{$key};
			$val2 =~ s/\n/<br>/g;

			$color++;
			if ($color % 2) { $cell_color = "#eeeeee"; }
			else { $cell_color = "#ffffff"; }

			print "<tr><td bgcolor=#ffeedd align=right><i>$key</i></td><td bgcolor=$cell_color>$val2\&nbsp;</td>\n";
			print "<input type=hidden name=\"$key\" value=\"$val\">\n";
		}

		print "<input type=hidden name=\"_EMAIL\" value=\"$in{'_EMAIL'}\">\n";
		print "</table><p>\n";

		print <<'EOF';
		<table><tr>
		<td><input type=button onClick="Submit()" value="  ̐\݂̎s "></td></form>
		<form action="order.cgi" method=POST>
		<td><input type=submit name="_cancel" value=" ~ \݂𒆎~ "></td></form></tr>
		<tr><td><font size=-2>JavaScriptLɂȂĂKv܂.</font></td>
		</tr></table>
EOF
	}
	else { print "<h3>IĂ܂</h3>\n"; }

	print <<"EOF";
	<h3><hr>[<A HREF="JavaScript:history.back()">Ỏ</A>]
	[<A HREF="$top">$go_name</A>]</h3>
	$center2
	</body></html>
EOF
	exit;
}

#[M
sub mail {

	unless ($in{'_EMAIL'} =~ /\b[-\w.]+@[-\w.]+\.[-\w]+\b/) { &error('L܂','d[͔pŐL.'); }

	#݌ɊǗ

	&lock;

	foreach $zaiko_file (keys %ZAIKO_TARGET) {

		@NEW = ();

		if (!open(IN,"$base_dir$zaiko_file\.csv")) { &error('G[',"$zaiko_fileI[vł܂."); }
		@lines = <IN>;
		close(IN);

		foreach $line (@lines) {

			$line =~ s/\n//g;
			$zaiko = '';

			#f[^o
			($code,$name,$tanka,$tax,$rem,$url,$zaiko,$type) = &DecodeCSV($line);

			if ($zaiko =~ /\d+/ && $zaiko ne '') {

				foreach $target (@ZAIKO_KANRI) {

					($TARGET_FILE,$CODE,$KAZU) = split(/:/,$target,3);

					$old = $zaiko;
					if ($CODE eq $code && $zaiko == 0) { &error("݌ɃG[","iR[h$codȅi͍݌ɂȂ܂.",'ʂ߂ēYi폜Ă.'); }
					if ($CODE eq $code) { $zaiko = $zaiko - $KAZU; }
					if ($zaiko < 0) { &error("݌ɃG[","iR[h$codȅi݌ɐ($old)鐔($KAZU)IĂ܂.",'ʂ߂ēYi폜ĂA߂ďiI.'); }
				}

				push(@EDIT,$code);
				push(@EDIT,$name);
				push(@EDIT,$tanka);
				push(@EDIT,$tax);
				push(@EDIT,$rem);
				push(@EDIT,$url);
				push(@EDIT,$zaiko);
				push(@EDIT,$type);
				$write = &EncodeCSV(@EDIT);
				@EDIT = ();
			}
			else { $write = $line; }

			push(@NEW,"$write\n")
		}

		if ($viewzaiko) {

			if (!open(OUT,"> $base_dir$zaiko_file\.csv")) { &error('G[',"$zaiko_fileI[vł܂."); }
			print OUT @NEW;
			close(OUT);
		}
	}

	if (-e $lockfile) { unlink($lockfile); }
	$| = 1;

	$host = $ENV{'REMOTE_HOST'};
	$addr = $ENV{'REMOTE_ADDR'};
	if ($host eq '') { $host = $addr; }
	if ($host eq $addr) { $host = gethostbyaddr(pack('C4',split(/\./,$host)),2) || $addr; }

	if ($hiho) {

		$in{'_SUBJECT'} = "\[$in{'_order'}\] Mail Order";
		if (!open(OUT,"| $sendmail -s \"$in{'_SUBJECT'}\" -f \"$in{'_EMAIL'}\" $mailto")) { &error('Error'); }
	}
	else {
		if (!open(OUT,"| $sendmail -t")) { &error('Error'); }

		print OUT "X-Processed: $date_now\n";
		print OUT "X-Mailer: SHPPING CARGO PRO by www.rescue.ne.jp $reg_code\n";
		print OUT "X-HTTP-REFERER: $ENV{'HTTP_REFERER'}\n";
		print OUT "To: $mailto\n";
		print OUT "From: $in{'_EMAIL'}\n";
		print OUT "Mime-Version: 1.0\n";
		print OUT "Content-Transfer-Encording: 7bit\n";
		print OUT "Content-Type: text/plain; charset=ISO-2022-JP\n";

		##print OUT &jis("Subject: \[$in{'_order'}\] $in{'_SUBJECT'}\n");

		$SUBJECT = &jis("\[$in{'_order'}\] $in{'_SUBJECT'}");
		$SUBJECT = &mailSubject_base64encode($SUBJECT);
		print OUT "Subject: $SUBJECT\n";

		print OUT "\n";
	}

	foreach (@out) {

		($name,$value) = split("\0");

		#[pɃ^Oϊ
		$value =~ s/&amp;/&/g;
		$value =~ s/&quot;/"/g;
		$value =~ s/&lt;/</g;
		$value =~ s/&gt;/>/g;
		if ($value =~ /(\.)$/) { $value =~ s/\./\n/; }

		if ($name eq 'ORDER' && $value ne '') { print OUT &jis("$value\n"); }
		elsif ($name eq 'ORDER' && $value eq '') { next; }
		elsif ($name eq '_EMAIL') { print OUT &jis("[\\ݎ҂̂d[]\n$value\n\n"); }
		elsif ($name =~ /^\_/) { next; }
		else { print OUT &jis("[$name]\n$value\n\n"); }
	}

	print OUT "\n";
	print OUT "Sender Information >>\n";
	print OUT "X-HTTP-User-Agent: $ENV{'HTTP_USER_AGENT'}\n";
	print OUT "X-Remote-host: $host\n";
	print OUT "X-Remote-Addr: $ENV{'REMOTE_ADDR'}\n";
	close(OUT);

	#ꎞt@C̍폜
	unlink "$tmp_dir$in{'_order'}\.bkt";

	#-------------------->

	#ʃNbL[̐ݒ(󏑍)
	print "Set-Cookie: $cookie_name=\n";

	#ʏo͊Jn
	print "Content-type: text/html\n\n";

	print <<"EOF";
	<HTML>
	<HEAD>
	<TITLE>$title_bar</TITLE>
	<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	$center1
	<table><tr><td>$msg_sended</td></tr></table>
	<p>
EOF
	print "<form>\n";
	print "<textarea cols=70 rows=20>";

	print " $date_now\n";
	print "tԍ $in{'_order'}\n";
	print "₢킹 $mailto\n\n";

	foreach (@out) {

		($name,$value) = split("\0");
		if ($value =~ /(\.)$/) { $value =~ s/\./\n/; }

		if ($name eq 'ORDER' && $value ne '') { print "$value\n"; }
		elsif ($name eq 'ORDER' && $value eq '') { next; }
		elsif ($name eq '_EMAIL') { print "[\\ݎ҂̂d[]\n$value\n\n"; }
		elsif ($name =~ /^\_/) { next; }
		else { print "[$name]\n$value\n\n"; }
	}

	print "</textarea></form><p>\n";

	if ($resp) {

		sleep(1);

		if ($hiho) {

			$in{'_SUBJECT'} = "\[$in{'_order'}\] Mail Order (COPY)";
			open(OUT,"| $sendmail -s \"$in{'_SUBJECT'}\" -f \"$mailto\" $in{'_EMAIL'}");
		}
		else {
			open(OUT,"| $sendmail -t");

			print OUT "X-Processed: $date_now\n";
			print OUT "X-Mailer: SHPPING CARGO PRO by www.rescue.ne.jp $reg_code\n";
			print OUT "X-HTTP-REFERER: $ENV{'HTTP_REFERER'}\n";
			print OUT "To: $in{'_EMAIL'}\n";
			print OUT "From: $mailto\n";
			print OUT "Mime-Version: 1.0\n";
			print OUT "Content-Transfer-Encording: 7bit\n";
			print OUT "Content-Type: text/plain; charset=ISO-2022-JP\n";

			##print OUT &jis("Subject: \[$in{'_order'}\] $in{'_SUBJECT'} (ʂ)\n");

			$SUBJECT = &jis("\[$in{'_order'}\] $in{'_SUBJECT'} (ʂ)");
			$SUBJECT = &mailSubject_base64encode($SUBJECT);
			print OUT "Subject: $SUBJECT\n";

			print OUT "\n";
		}

		print OUT &jis("$head\n");

		foreach (@out) {

			($name,$value) = split("\0");

			#[pɃ^Oϊ
			$value =~ s/&amp;/&/g;
			$value =~ s/&quot;/"/g;
			$value =~ s/&lt;/</g;
			$value =~ s/&gt;/>/g;
			if ($value =~ /(\.)$/) { $value =~ s/\./\n/; }

			if ($name eq 'ORDER' && $value ne '') { print OUT &jis("$value\n"); }
			elsif ($name eq 'ORDER' && $value eq '') { next; }
			elsif ($name eq '_EMAIL') { print OUT &jis("[\\ݎ҂̂d[]\n$value\n\n"); }
			elsif ($name =~ /^\_/) { next; }
			else { print OUT &jis("[$name]\n$value\n\n"); }
		}

		print OUT &jis("$sign\n");

		close(OUT);
	}

	print <<"EOF";
	<p>
	<table><tr><td>$msg_sended2</td></tr></table><p>
	<h3><hr>[<A HREF="JavaScript:history.back()">Ỏ</A>]
	[<A HREF="$end">$end_name</A>]</h3>
	$center2
	</body></html>
EOF

exit;

}

sub EncodeCSV {

	local(@fields) = @_;
	local(@CSV) = ();

	foreach $text (@fields) {

		$text =~ s/&amp;/&/g;
		$text =~ s/&quot;/"/g;
		$text =~ s/&lt;/</g;
		$text =~ s/&gt;/>/g;

		$text =~ s/"/""/g;
		if ($text =~ /,|"/) { $text = "\"$text\""; }

		push(@CSV,$text);
	}

	return join(',',@CSV);
}

sub DecodeCSV {

	local($text) = @_;
	local(@fields) = ();
	local($a);

	$text =~ s/\n//;
	if ($text eq '') { return (); }

	while ($text =~ m/"([^\\]*(\\.[^\\]*)*)",?|([^,]+),?|,/g) {

		$a = defined($1) ? $1 : $3;
		$a =~ s/""/"/g;

		$a =~ s/&/&amp;/g;
		$a =~ s/"/&quot;/g;
		$a =~ s/</&lt;/g;
		$a =~ s/>/&gt;/g;

		push(@fields,$a);
	}
	push(@fields, undef) if $text =~ m/,$/;

	@fields;
}

sub lock {

	# bN̎ symlink()D
	$symlink_check = (eval { symlink("",""); }, $@ eq "");
	if (!$symlink_check) {

		$c = 0;
		while(-f "$lockfile") { # file

			$c++;
			if ($c >= 3) { &error('gCG[','܍GĂ\܂.','߂ĂxsĂ݂Ă.'); }
			sleep(2);
		}
		open(LOCK,">$lockfile");
		close(LOCK);
	}
	else {
		local($retry) = 3;
		while (!symlink(".", $lockfile)) { # symlink

			if (--$retry <= 0) { &error('gCG[','܍GĂ\܂.','߂ĂxsĂ݂Ă.'); }
			sleep(2);
		}
	}
}

sub error {

	local (@msg) = @_;
	local ($i);

	if (-e $lockfile) { unlink($lockfile); }

	print "Content-type: text/html\n\n";

	print <<"EOF";
	<HTML>
	<HEAD>
	<TITLE>$title_bar</TITLE>
	<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	$center1
	<h1>$_[0]</h1>
	<table><tr><td>
EOF
	foreach $i (1 .. $#msg) { print "$msg[$i]<br>\n"; }

	print <<"EOF";
	</td></tr></table>
	<h4>[<A HREF="JavaScript:history.back()">Ỏʂɖ߂</A>]</h4>
	$center2
	</body></html>
EOF
	exit;
}

sub jis {

	local($msg) = @_;
	##&jcode'convert(*msg,'jis');	# for Perl4
	jcode::convert(\$msg,'jis');	# for Perl5
	##use Jcode; $jis = Jcode::convert($msg,'jis'); # for use Jcode
	return $msg;
}

sub mailSubject_base64encode { ## MIME/Base64.pm

	my $res = "";
	my $eol = $_[1];
	$eol = "\n" unless defined $eol;
	pos($_[0]) = 0;
	while ($_[0] =~ /(.{1,45})/gs) {
		$res .= substr(pack('u', $1), 1);
		chop($res);
	}
	$res =~ tr|` -_|AA-Za-z0-9+/|;
	$padding = (3 - length($_[0]) % 3) % 3;
	$res =~ s/.{$padding}$/'=' x $padding/e if $padding;
	#if (length $eol) { $res =~ s/(.{1,76})/$1$eol/g; }
	"=?ISO-2022-JP?B?$res?=";
}

sub mailSubject_base64encode_old {

	use MIME::Base64;
	local($line) = @_;
	$Subject = $line;
	$Subject = &jis($Subject);
	$Subject = encode_base64($Subject,"");
	$Subject = "=?ISO-2022-JP?B?$Subject?=";
	return $Subject;

}
